<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>EDMA3 Resource Manager: Interface Definition for EDMA3 Resource Manager Layer</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Interface Definition for EDMA3 Resource Manager Layer<br>
<small>
[<a class="el" href="group__Edma3RMIntrMgrMain.html">EDMA3 Interrupt Manager Interface</a>]</small>
</h1><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Data Structures</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structEDMA3__RM__GblConfigParams.html">EDMA3_RM_GblConfigParams</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Init-time Configuration structure for EDMA3 controller, to provide Global SoC specific Information.  <a href="structEDMA3__RM__GblConfigParams.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structEDMA3__RM__InstanceInitConfig.html">EDMA3_RM_InstanceInitConfig</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Init-time Region Specific Configuration structure for EDMA3 RM, to provide region specific Information.  <a href="structEDMA3__RM__InstanceInitConfig.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structEDMA3__RM__Param.html">EDMA3_RM_Param</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Used to Initialize the Resource Manager Instance.  <a href="structEDMA3__RM__Param.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structEDMA3__RM__MiscParam.html">EDMA3_RM_MiscParam</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Used to specify the miscellaneous options during Resource Manager Initialization.  <a href="structEDMA3__RM__MiscParam.html#_details">More...</a><br></td></tr>
<tr><td colspan="2"><br><h2>Modules</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Edma3RMUsage.html">EDMA3 Resource Manager Usage Guidelines</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Edma3RMErrCode.html">Error Codes</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Usage of Resource Manager. <br></td></tr>

<p>
<tr><td colspan="2"><br><h2>Typedefs</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Edma3RMMain.html#g95ce8c6a9989cc4bbd29e0234e6ee5e4">EDMA3_RM_RegionId</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">EDMA3 Region Id.  <a href="#g95ce8c6a9989cc4bbd29e0234e6ee5e4"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Edma3RMMain.html#g73da34ea04a5d4c536919febc341ff2a">EDMA3_RM_EventQueue</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">EDMA3 Event Queue assignment.  <a href="#g73da34ea04a5d4c536919febc341ff2a"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">EDMA3_RM_Result&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Edma3RMMain.html#gdc4459024208af43ca53740f5f0e24f2">EDMA3_RM_create</a> (unsigned int phyCtrllerInstId, const <a class="el" href="structEDMA3__RM__GblConfigParams.html">EDMA3_RM_GblConfigParams</a> *gblCfgParams, const void *miscParam)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create EDMA3 Resource Manager Object.  <a href="#gdc4459024208af43ca53740f5f0e24f2"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">EDMA3_RM_Result&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Edma3RMMain.html#g91cc5101fd09c700b6d2a2e72baf88fe">EDMA3_RM_delete</a> (unsigned int phyCtrllerInstId, const void *param)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Delete EDMA3 Resource Manager Object.  <a href="#g91cc5101fd09c700b6d2a2e72baf88fe"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">EDMA3_RM_Handle&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Edma3RMMain.html#g06b18003d700ce3c227f70e422dd9897">EDMA3_RM_open</a> (unsigned int phyCtrllerInstId, const <a class="el" href="structEDMA3__RM__Param.html">EDMA3_RM_Param</a> *initParam, EDMA3_RM_Result *errorCode)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Open EDMA3 Resource Manager Instance.  <a href="#g06b18003d700ce3c227f70e422dd9897"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">EDMA3_RM_Result&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Edma3RMMain.html#g92776ae6a8795fe8ffce672e8a04e409">EDMA3_RM_close</a> (EDMA3_RM_Handle hEdmaResMgr, const void *param)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Close EDMA3 Resource Manager Instance.  <a href="#g92776ae6a8795fe8ffce672e8a04e409"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Top-level Encapsulation of all documentation for EDMA3 Resource Manager Layer <hr><h2>Typedef Documentation</h2>
<a class="anchor" name="g73da34ea04a5d4c536919febc341ff2a"></a><!-- doxytag: member="edma3_rm.h::EDMA3_RM_EventQueue" ref="g73da34ea04a5d4c536919febc341ff2a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__Edma3RMMain.html#g73da34ea04a5d4c536919febc341ff2a">EDMA3_RM_EventQueue</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
EDMA3 Event Queue assignment. 
<p>
There can be 8 Event Queues. Either of them can be assigned to a DMA/QDMA channel using this. 
</div>
</div><p>
<a class="anchor" name="g95ce8c6a9989cc4bbd29e0234e6ee5e4"></a><!-- doxytag: member="edma3_rm.h::EDMA3_RM_RegionId" ref="g95ce8c6a9989cc4bbd29e0234e6ee5e4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__Edma3RMMain.html#g95ce8c6a9989cc4bbd29e0234e6ee5e4">EDMA3_RM_RegionId</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
EDMA3 Region Id. 
<p>
Use this to assign channels/PaRAM sets/TCCs to a particular Region. 
</div>
</div><p>
<hr><h2>Function Documentation</h2>
<a class="anchor" name="g92776ae6a8795fe8ffce672e8a04e409"></a><!-- doxytag: member="edma3_rm.h::EDMA3_RM_close" ref="g92776ae6a8795fe8ffce672e8a04e409" args="(EDMA3_RM_Handle hEdmaResMgr, const void *param)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">EDMA3_RM_Result EDMA3_RM_close           </td>
          <td>(</td>
          <td class="paramtype">EDMA3_RM_Handle&nbsp;</td>
          <td class="paramname"> <em>hEdmaResMgr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const void *&nbsp;</td>
          <td class="paramname"> <em>param</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Close EDMA3 Resource Manager Instance. 
<p>
This API is used to close a previously opened EDMA3 RM Instance.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>hEdmaResMgr</em>&nbsp;</td><td>[IN] Handle to the previously opened Resource Manager Instance. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>param</em>&nbsp;</td><td>[IN] For possible future use.</td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>EDMA3_RM_SOK or EDMA3_RM Error Code</dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>This function disables the global interrupts (by calling API edma3OsProtectEntry with protection level EDMA3_OS_PROTECT_INTERRUPT) while modifying the global RM data structures, to make it re-entrant. </dd></dl>

<p>
If this is the Master Instance, reset the static variable 'masterExists[]'.
<p>References <a class="el" href="edma3resmgr_8h_source.html#l00218">EDMA3_RM_Instance::avlblDmaChannels</a>, <a class="el" href="edma3resmgr_8h_source.html#l00224">EDMA3_RM_Instance::avlblPaRAMSets</a>, <a class="el" href="edma3resmgr_8h_source.html#l00221">EDMA3_RM_Instance::avlblQdmaChannels</a>, <a class="el" href="edma3resmgr_8h_source.html#l00227">EDMA3_RM_Instance::avlblTccs</a>, <a class="el" href="edma3resmgr_8h_source.html#l00122">EDMA3_RM_CLOSED</a>, <a class="el" href="edma3__rm_8h_source.html#l00641">EDMA3_RM_E_INVALID_PARAM</a>, <a class="el" href="edma3__rm_8h_source.html#l00638">EDMA3_RM_E_OBJ_NOT_OPENED</a>, <a class="el" href="edma3resmgr_8h_source.html#l00120">EDMA3_RM_OPENED</a>, <a class="el" href="edma3resmgr_8h_source.html#l00184">EDMA3_RM_Obj::gblCfgParams</a>, <a class="el" href="edma3resmgr_8h_source.html#l00206">EDMA3_RM_Instance::initParam</a>, <a class="el" href="edma3__rm_8h_source.html#l00985">EDMA3_RM_Param::isMaster</a>, <a class="el" href="edma3__rm_8h_source.html#l00720">EDMA3_RM_GblConfigParams::numDmaChannels</a>, <a class="el" href="edma3resmgr_8h_source.html#l00175">EDMA3_RM_Obj::numOpens</a>, <a class="el" href="edma3__rm_8h_source.html#l00732">EDMA3_RM_GblConfigParams::numPaRAMSets</a>, <a class="el" href="edma3__rm_8h_source.html#l00729">EDMA3_RM_GblConfigParams::numTccs</a>, <a class="el" href="edma3resmgr_8h_source.html#l00169">EDMA3_RM_Obj::phyCtrllerInstId</a>, <a class="el" href="edma3resmgr_8h_source.html#l00215">EDMA3_RM_Instance::pResMgrObjHandle</a>, <a class="el" href="edma3resmgr_8h_source.html#l00209">EDMA3_RM_Instance::shadowRegs</a>, and <a class="el" href="edma3resmgr_8h_source.html#l00172">EDMA3_RM_Obj::state</a>.</p>

</div>
</div><p>
<a class="anchor" name="gdc4459024208af43ca53740f5f0e24f2"></a><!-- doxytag: member="edma3_rm.h::EDMA3_RM_create" ref="gdc4459024208af43ca53740f5f0e24f2" args="(unsigned int phyCtrllerInstId, const EDMA3_RM_GblConfigParams *gblCfgParams, const void *miscParam)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">EDMA3_RM_Result EDMA3_RM_create           </td>
          <td>(</td>
          <td class="paramtype">unsigned int&nbsp;</td>
          <td class="paramname"> <em>phyCtrllerInstId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structEDMA3__RM__GblConfigParams.html">EDMA3_RM_GblConfigParams</a> *&nbsp;</td>
          <td class="paramname"> <em>gblCfgParams</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const void *&nbsp;</td>
          <td class="paramname"> <em>miscParam</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Create EDMA3 Resource Manager Object. 
<p>
This API is used to create the EDMA3 Resource Manager Object. It should be called only ONCE for each EDMA3 hardware instance.<p>
Init-time Configuration structure for EDMA3 hardware is provided to pass the SoC specific information. This configuration information could be provided by the user at init-time. In case user doesn't provide it, this information could be taken from the SoC specific configuration file edma3_&lt;SOC_NAME&gt;_cfg.c, in case it is available.<p>
This API clears the error specific registers (EMCR/EMCRh, QEMCR, CCERRCLR) and sets the TCs priorities and Event Queues' watermark levels, if the 'miscParam' argument is NULL. User can avoid these registers' programming (in some specific use cases) by SETTING the 'isSlave' field of 'EDMA3_RM_MiscParam' configuration structure and passing this structure as the third argument (miscParam).<p>
After successful completion of this API, Resource Manager Object's state changes to EDMA3_RM_CREATED from EDMA3_RM_DELETED.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>phyCtrllerInstId</em>&nbsp;</td><td>[IN] EDMA3 Controller Instance Id (Hardware instance id, starting from 0). </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>gblCfgParams</em>&nbsp;</td><td>[IN] SoC specific configuration structure for the EDMA3 Hardware. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>miscParam</em>&nbsp;</td><td>[IN] Misc configuration options provided in the structure 'EDMA3_RM_MiscParam'. For default options, user can pass NULL in this argument.</td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>EDMA3_RM_SOK or EDMA3_RM Error Code </dd></dl>

<p>
Used to reset the Internal EDMA3 Resource Manager Data Structures for the first time.<p>
We are NOT checking 'gblCfgParams' for NULL. If user has passed NULL, default config info will be taken from config file. 'param' is also not being checked because it could be NULL also.<p>
Check whether user has passed the Global Config Info. If yes, copy it to the driver data structures. Else, use the info from the config file edma3Cfg.c<p>
Check whether DMA channel to PaRAM Set mapping exists or not. If it does not exist, set the mapping array as 1-to-1 mapped.<p>
Update the actual number of PaRAM sets.<p>
Check the misc configuration options structure. Check whether the global registers' initialization is required or not. It is required ONLY if RM is running on the Master Processor.
<p>References <a class="el" href="edma3__rm_8h_source.html#l00824">EDMA3_RM_GblConfigParams::dmaChannelPaRAMMap</a>, <a class="el" href="edma3__rm_8h_source.html#l00758">EDMA3_RM_GblConfigParams::dmaChPaRAMMapExists</a>, <a class="el" href="edma3resmgr_8h_source.html#l00118">EDMA3_RM_CREATED</a>, <a class="el" href="edma3resmgr_8h_source.html#l00116">EDMA3_RM_DELETED</a>, <a class="el" href="edma3__rm_8h_source.html#l00641">EDMA3_RM_E_INVALID_PARAM</a>, <a class="el" href="edma3__rm_8h_source.html#l00626">EDMA3_RM_E_OBJ_NOT_DELETED</a>, <a class="el" href="edma3resmgr_8h_source.html#l00184">EDMA3_RM_Obj::gblCfgParams</a>, <a class="el" href="edma3__rm_8h_source.html#l01030">EDMA3_RM_MiscParam::isSlave</a>, <a class="el" href="edma3__rm_8h_source.html#l00720">EDMA3_RM_GblConfigParams::numDmaChannels</a>, <a class="el" href="edma3resmgr_8h_source.html#l00175">EDMA3_RM_Obj::numOpens</a>, <a class="el" href="edma3__rm_8h_source.html#l00732">EDMA3_RM_GblConfigParams::numPaRAMSets</a>, <a class="el" href="edma3__rm_8h_source.html#l00723">EDMA3_RM_GblConfigParams::numQdmaChannels</a>, <a class="el" href="edma3resmgr_8h_source.html#l00280">EDMA3_RM_ChBoundResources::paRAMId</a>, <a class="el" href="edma3resmgr_8h_source.html#l00169">EDMA3_RM_Obj::phyCtrllerInstId</a>, <a class="el" href="edma3resmgr_8h_source.html#l00172">EDMA3_RM_Obj::state</a>, and <a class="el" href="edma3resmgr_8h_source.html#l00283">EDMA3_RM_ChBoundResources::tcc</a>.</p>

</div>
</div><p>
<a class="anchor" name="g91cc5101fd09c700b6d2a2e72baf88fe"></a><!-- doxytag: member="edma3_rm.h::EDMA3_RM_delete" ref="g91cc5101fd09c700b6d2a2e72baf88fe" args="(unsigned int phyCtrllerInstId, const void *param)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">EDMA3_RM_Result EDMA3_RM_delete           </td>
          <td>(</td>
          <td class="paramtype">unsigned int&nbsp;</td>
          <td class="paramname"> <em>phyCtrllerInstId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const void *&nbsp;</td>
          <td class="paramname"> <em>param</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Delete EDMA3 Resource Manager Object. 
<p>
This API is used to delete the EDMA3 RM Object. It should be called once for each EDMA3 hardware instance, ONLY after closing all the previously opened EDMA3 RM Instances.<p>
After successful completion of this API, Resource Manager Object's state changes to EDMA3_RM_DELETED.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>phyCtrllerInstId</em>&nbsp;</td><td>[IN] EDMA3 Phy Controller Instance Id (Hardware instance id, starting from 0). </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>param</em>&nbsp;</td><td>[IN] For possible future use.</td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>EDMA3_RM_SOK or EDMA3_RM Error Code </dd></dl>

<p>
If number of RM Instances is 0, then state should be EDMA3_RM_CLOSED OR EDMA3_RM_CREATED.<p>
If number of RM Instances is NOT 0, then this function SHOULD NOT be called by anybody.<p>
Change state to EDMA3_RM_DELETED 
<p>References <a class="el" href="edma3resmgr_8h_source.html#l00122">EDMA3_RM_CLOSED</a>, <a class="el" href="edma3resmgr_8h_source.html#l00118">EDMA3_RM_CREATED</a>, <a class="el" href="edma3resmgr_8h_source.html#l00116">EDMA3_RM_DELETED</a>, <a class="el" href="edma3__rm_8h_source.html#l00641">EDMA3_RM_E_INVALID_PARAM</a>, <a class="el" href="edma3__rm_8h_source.html#l00656">EDMA3_RM_E_INVALID_STATE</a>, <a class="el" href="edma3__rm_8h_source.html#l00632">EDMA3_RM_E_OBJ_NOT_CLOSED</a>, and <a class="el" href="edma3resmgr_8h_source.html#l00172">EDMA3_RM_Obj::state</a>.</p>

</div>
</div><p>
<a class="anchor" name="g06b18003d700ce3c227f70e422dd9897"></a><!-- doxytag: member="edma3_rm.h::EDMA3_RM_open" ref="g06b18003d700ce3c227f70e422dd9897" args="(unsigned int phyCtrllerInstId, const EDMA3_RM_Param *initParam, EDMA3_RM_Result *errorCode)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">EDMA3_RM_Handle EDMA3_RM_open           </td>
          <td>(</td>
          <td class="paramtype">unsigned int&nbsp;</td>
          <td class="paramname"> <em>phyCtrllerInstId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structEDMA3__RM__Param.html">EDMA3_RM_Param</a> *&nbsp;</td>
          <td class="paramname"> <em>initParam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">EDMA3_RM_Result *&nbsp;</td>
          <td class="paramname"> <em>errorCode</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Open EDMA3 Resource Manager Instance. 
<p>
This API is used to open an EDMA3 Resource Manager Instance. It could be called multiple times, for each possible EDMA3 shadow region. Maximum EDMA3_MAX_RM_INSTANCES instances are allowed for each EDMA3 hardware instance.<p>
Also, only ONE Master Resource Manager Instance is permitted. This master instance (and hence the region to which it belongs) will only receive the EDMA3 interrupts, if enabled.<p>
User could pass the instance specific configuration structure (initParam-&gt;rmInstInitConfig) as a part of the 'initParam' structure, during init-time. In case user doesn't provide it, this information could be taken from the SoC specific configuration file edma3_&lt;SOC_NAME&gt;_cfg.c, in case it is available.<p>
By default, this Resource Manager instance will clear the PaRAM Sets while allocating them. To change the default behavior, user should use the IOCTL interface appropriately.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>phyCtrllerInstId</em>&nbsp;</td><td>[IN] EDMA3 Controller Instance Id (Hardware instance id, starting from 0). </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>initParam</em>&nbsp;</td><td>[IN] Used to Initialize the Resource Manager Instance (Master or Slave). </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>errorCode</em>&nbsp;</td><td>[OUT] Error code while opening RM instance.</td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>Handle to the opened Resource Manager instance Or NULL in case of error.</dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>This function disables the global interrupts (by calling API edma3OsProtectEntry with protection level EDMA3_OS_PROTECT_INTERRUPT) while modifying the global RM data structures, to make it re-entrant.</dd></dl>
This API is used to open an EDMA3 Resource Manager Instance. It could be called multiple times, for each possible EDMA3 shadow region. Maximum EDMA3_MAX_RM_INSTANCES instances are allowed for each EDMA3 hardware instance.<p>
Also, only ONE Master Resource Manager Instance is permitted. This master instance (and hence the region to which it belongs) will only receive the EDMA3 interrupts, if enabled.<p>
User could pass the instance specific configuration structure (initParam-&gt;rmInstInitConfig) as a part of the 'initParam' structure, during init-time. In case user doesn't provide it, this information could be taken from the SoC specific configuration file edma3_&lt;SOC_NAME&gt;_cfg.c, in case it is available.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>phyCtrllerInstId</em>&nbsp;</td><td>[IN] EDMA3 Controller Instance Id (Hardware instance id, starting from 0). </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>initParam</em>&nbsp;</td><td>[IN] Used to Initialize the Resource Manager Instance (Master or Slave). </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>errorCode</em>&nbsp;</td><td>[OUT] Error code while opening RM instance.</td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>Handle to the opened Resource Manager instance Or NULL in case of error.</dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>This function disables the global interrupts (by calling API edma3OsProtectEntry with protection level EDMA3_OS_PROTECT_INTERRUPT) while modifying the global RM data structures, to make it re-entrant. </dd></dl>

<p>
Check state of RM Object. If no RM instance is opened and this is the first one, then state should be created/closed.<p>
If num of instances opened is more than 0 and less than max allowed, then state should be opened.<p>
Check whether user has passed information about resources owned and reserved by this instance. This is region specific information. If he has not passed, dafault static config info will be taken from the config file edma3Cfg.c, according to the regionId specified.<p>
resMgrIdx specifies the RM instance number created just now. Use it to populate the userInitConfig [].<p>
By default, PaRAM Sets allocated using this RM Instance will get cleared during their allocation. User can stop their clearing by calling specific IOCTL command.<p>
By default, during the EDMA3_RM_allocLogicalChannel (), global EDMA3 registers (DCHMAP/QCHMAP) and the allocated PaRAM Set will be programmed accordingly, for users using this RM Instance. User can stop their pre-programming by calling EDMA3_RM_IOCTL_SET_GBL_REG_MODIFY_OPTION IOCTL command.
<p>References <a class="el" href="edma3resmgr_8h_source.html#l00218">EDMA3_RM_Instance::avlblDmaChannels</a>, <a class="el" href="edma3resmgr_8h_source.html#l00224">EDMA3_RM_Instance::avlblPaRAMSets</a>, <a class="el" href="edma3resmgr_8h_source.html#l00221">EDMA3_RM_Instance::avlblQdmaChannels</a>, <a class="el" href="edma3resmgr_8h_source.html#l00227">EDMA3_RM_Instance::avlblTccs</a>, <a class="el" href="edma3__rm_8h_source.html#l00824">EDMA3_RM_GblConfigParams::dmaChannelPaRAMMap</a>, <a class="el" href="edma3__rm_8h_source.html#l00758">EDMA3_RM_GblConfigParams::dmaChPaRAMMapExists</a>, <a class="el" href="edma3__rm_8h_source.html#l01402">EDMA3_RM_CH_NO_PARAM_MAP</a>, <a class="el" href="edma3resmgr_8h_source.html#l00122">EDMA3_RM_CLOSED</a>, <a class="el" href="edma3resmgr_8h_source.html#l00118">EDMA3_RM_CREATED</a>, <a class="el" href="edma3__rm_8h_source.html#l00641">EDMA3_RM_E_INVALID_PARAM</a>, <a class="el" href="edma3__rm_8h_source.html#l00656">EDMA3_RM_E_INVALID_STATE</a>, <a class="el" href="edma3__rm_8h_source.html#l00659">EDMA3_RM_E_MAX_RM_INST_OPENED</a>, <a class="el" href="edma3__rm_8h_source.html#l00665">EDMA3_RM_E_RM_MASTER_ALREADY_EXISTS</a>, <a class="el" href="edma3resmgr_8h_source.html#l00120">EDMA3_RM_OPENED</a>, <a class="el" href="edma3resmgr_8h_source.html#l00184">EDMA3_RM_Obj::gblCfgParams</a>, <a class="el" href="edma3__rm_8h_source.html#l00764">EDMA3_RM_GblConfigParams::globalRegs</a>, <a class="el" href="edma3resmgr_8h_source.html#l00206">EDMA3_RM_Instance::initParam</a>, <a class="el" href="edma3__rm_8h_source.html#l00985">EDMA3_RM_Param::isMaster</a>, <a class="el" href="edma3__rm_8h_source.html#l00720">EDMA3_RM_GblConfigParams::numDmaChannels</a>, <a class="el" href="edma3resmgr_8h_source.html#l00175">EDMA3_RM_Obj::numOpens</a>, <a class="el" href="edma3__rm_8h_source.html#l00732">EDMA3_RM_GblConfigParams::numPaRAMSets</a>, <a class="el" href="edma3__rm_8h_source.html#l00743">EDMA3_RM_GblConfigParams::numRegions</a>, <a class="el" href="edma3__rm_8h_source.html#l00729">EDMA3_RM_GblConfigParams::numTccs</a>, <a class="el" href="edma3__rm_8h_source.html#l00923">EDMA3_RM_InstanceInitConfig::ownDmaChannels</a>, <a class="el" href="edma3__rm_8h_source.html#l00920">EDMA3_RM_InstanceInitConfig::ownPaRAMSets</a>, <a class="el" href="edma3__rm_8h_source.html#l00926">EDMA3_RM_InstanceInitConfig::ownQdmaChannels</a>, <a class="el" href="edma3__rm_8h_source.html#l00929">EDMA3_RM_InstanceInitConfig::ownTccs</a>, <a class="el" href="edma3resmgr_8h_source.html#l00245">EDMA3_RM_Instance::paramInitRequired</a>, <a class="el" href="edma3resmgr_8h_source.html#l00215">EDMA3_RM_Instance::pResMgrObjHandle</a>, <a class="el" href="edma3__rm_8h_source.html#l00978">EDMA3_RM_Param::regionId</a>, <a class="el" href="edma3__rm_8h_source.html#l01007">EDMA3_RM_Param::regionInitEnable</a>, <a class="el" href="edma3resmgr_8h_source.html#l00264">EDMA3_RM_Instance::regModificationRequired</a>, <a class="el" href="edma3__rm_8h_source.html#l00938">EDMA3_RM_InstanceInitConfig::resvdPaRAMSets</a>, <a class="el" href="edma3__rm_8h_source.html#l00995">EDMA3_RM_Param::rmInstInitConfig</a>, <a class="el" href="edma3__rm_8h_source.html#l01002">EDMA3_RM_Param::rmSemHandle</a>, <a class="el" href="edma3resmgr_8h_source.html#l00209">EDMA3_RM_Instance::shadowRegs</a>, and <a class="el" href="edma3resmgr_8h_source.html#l00172">EDMA3_RM_Obj::state</a>.</p>

</div>
</div><p>
</div>
<hr size="1"><address style="text-align: right;"><small>Generated on Tue Jul 7 19:26:48 2009 for EDMA3 Resource Manager by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.9 </small></address>
</body>
</html>
